package org.example.saxonbug;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import javax.xml.xquery.XQConnection;
import javax.xml.xquery.XQDataSource;
import javax.xml.xquery.XQException;
import javax.xml.xquery.XQPreparedExpression;
import javax.xml.xquery.XQResultSequence;

import com.saxonica.xqj.SaxonXQDataSource;

public class Main {

    public static void main(String[] args) throws Exception {
        XQDataSource dataSource = new SaxonXQDataSource();
        XQConnection connection = dataSource.getConnection();

        System.out.println("With output parameters passed as Java Properties");
        Properties outputParameters = new Properties();
        outputParameters.put("method", "xhtml");
        outputParameters.put("html-version", "5.0");
        executeQuery(connection, "/with-java-parameters.xq", outputParameters);
        System.out.println();

        System.out.println("With inline output: parameters");
        executeQuery(connection, "/with-inline-parameters.xq", null);
        System.out.println();

        System.out.println("With output:parameter-document");
        executeQuery(connection, "/with-parameter-document.xq", null);
        System.out.println();
    }

    private static void executeQuery(XQConnection connection, String queryResource, Properties outputParameters)
            throws XQException, IOException {
        try (InputStream query = Main.class.getResourceAsStream(queryResource)) {
            XQPreparedExpression expression = connection.prepareExpression(query);
            XQResultSequence results = expression.executeQuery();
            results.writeSequence(System.out, outputParameters);
        }
    }
}
